import { MatchEntity } from '../../../domain/match.entity';
import { Candidate, Processor } from '../../types/algorithm.types';
import { MatchQuery } from './match.query';
import { AdRepositoryPort } from '@modules/ad/core/application/ports/ad.repository.port';

export abstract class Algorithm {
  protected candidates: Candidate[];
  protected processors: Processor[];
  constructor(
    protected readonly query: MatchQuery,
    protected readonly repository: AdRepositoryPort,
  ) {}

  /**
   * Filter candidates that matches the query
   */
  abstract match(): Promise<MatchEntity[]>;
}
