import { MatchQuery } from '../core/application/queries/match/match.query';
import { AlgorithmType } from '../core/application/types/algorithm.types';
import { Role } from '../core/domain/ad.types';

export class AdSelector {
  static select = (role: Role, query: MatchQuery): string => {
    switch (query.algorithmType) {
      case AlgorithmType.PASSENGER_ORIENTED:
      default:
        return `SELECT
        ad.uuid,frequency,public.st_astext(matcher.ad.waypoints) as waypoints,
        "fromDate","toDate",
        "seatsProposed","seatsRequested",
        strict,
        "driverDuration","driverDistance",
        "passengerDuration","passengerDistance",
        "fwdAzimuth","backAzimuth",
        si.day,si.time,si.margin
        FROM ad LEFT JOIN schedule_item si ON ad.uuid = si."adUuid"
        WHERE driver=True`;
    }
  };
}
